package com.demoad.plugin_codelab.ASDK;

import static android.content.ContentValues.TAG;
import static com.demoad.plugin_codelab.ASDK.BaseApp.adModel;
import static com.demoad.plugin_codelab.ASDK.BaseApp.adTime;
import static com.demoad.plugin_codelab.ASDK.BaseApp.baseApp;
import static com.demoad.plugin_codelab.ASDK.BaseApp.currentActivity;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.appcompat.widget.AppCompatButton;
import androidx.browser.customtabs.CustomTabsIntent;

import com.demoad.plugin_codelab.PluginCodelabPlugin;
import com.demoad.plugin_codelab.R;
import com.demoad.plugin_codelab.adhelper.ads.Pack5Banner;
import com.demoad.plugin_codelab.adhelper.ads.Pack5Interstitial;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeBigUpMedia;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeCustom;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeNormal;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeRegular;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeSmall;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeSmallDown_Nomedia;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeSmallSide;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeSmallUp;
import com.demoad.plugin_codelab.adhelper.ads.Pack5NativeBigUpNoMedia;
import com.demoad.plugin_codelab.source.Globals;
import com.openmediation.sdk.banner.BannerAd;
import com.openmediation.sdk.banner.BannerAdListener;
import com.openmediation.sdk.nativead.AdIconView;
import com.openmediation.sdk.nativead.AdInfo;
import com.openmediation.sdk.nativead.NativeAdListener;
import com.openmediation.sdk.utils.error.Error;
import com.openmediation.sdk.video.RewardedVideoAd;

import java.lang.ref.WeakReference;
import java.util.Random;

public class ads {
    public static final String INSTALLER_ADB = "adb";
    public static final String INSTALLER_PACKAGE_INSTALLER_NOUGAT = "com.google.android.packageinstaller";
    public static final String INSTALLER_PACKAGE_INSTALLER_NOUGAT2 = "com.android.packageinstaller";

    protected static boolean installedFromMarket(Context contexts) {
        boolean result = false;
        if (Globals.getInstance().getUtmCampaign(contexts) != null && Globals.getInstance().getUtmMedium(contexts) != null && Globals.getInstance().getUtmSource(contexts) != null) {
            if (Globals.getInstance().getUtmCampaign(contexts).equalsIgnoreCase("marketing") && Globals.getInstance().getUtmCampaign(contexts).equalsIgnoreCase("marketing")) {
                return true;
            }
        }
        return result;
    }

    public void openPlayGames(Context context) {
        String urlString = adModel.getQlink();
        Log.e(TAG, "onClick: " + urlString);
        Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(urlString));
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        intent.setPackage("com.android.chrome");
        try {
            context.startActivity(intent);
        } catch (ActivityNotFoundException ex) {
            // Chrome browser presumably not installed so allow user to choose instead
            intent.setPackage(null);
            context.startActivity(intent);
        }
    }

    public void showIntAds(isAdLoaded isIntersttialLoded) {
        if (adModel != null) {
            if (adModel.isIsad()) {

                new ads().showints(isIntersttialLoded);
            }
        }
    }

    void showints(isAdLoaded isIntersttialLoded) {
        if (adModel != null) {
            if (adModel.isIsad()) {

                showint(currentActivity, isIntersttialLoded);

            }
        }
    }

    void showint(Activity activity, final isAdLoaded isIntersttialLoded) {
        if (adModel.isIsopenmediation()) {
            if (com.openmediation.sdk.interstitial.InterstitialAd.isReady()) {
                adTime = 1;
                com.openmediation.sdk.interstitial.InterstitialAd.showAd();
            } else {
                com.openmediation.sdk.interstitial.InterstitialAd.loadAd();

                adTime = 1;
            }
        } else if (adModel.isIsqurekaads()) {

            CustomTabsIntent.Builder builder = new CustomTabsIntent.Builder();
            CustomTabsIntent customTabsIntent = builder.build();

            Intent intent = new Intent(String.valueOf(Intent.FLAG_ACTIVITY_NO_USER_ACTION));
            intent.setPackage("com.android.chrome");
            PendingIntent pendingIntent = PendingIntent.getActivity(activity, 100, intent, PendingIntent.FLAG_IMMUTABLE);

            Bitmap bitmap = BitmapFactory.decodeResource(activity.getResources(), R.drawable.ic_ad);
            builder.setActionButton(bitmap, "Ad", pendingIntent);
            customTabsIntent.launchUrl(activity, Uri.parse(adModel.getQlink()));

        } else {
            adTime = 1;
            Pack5Interstitial.showFullInterstitialAdsMain(activity, !adModel.isIseveryads(), new Pack5Interstitial.OnInterstitialAdsListner() {
                @Override
                public void onFinishInterstitialAds() {
                    isIntersttialLoded.callback(true);
                }
            });

        }
    }

    public void showreward() {
        if (adModel.isIsopenmediation()) {
            if (adModel != null) {
                if (adModel.isIsad()) {
                    if (RewardedVideoAd.isReady()) {
                        adTime = 1;
                        RewardedVideoAd.showAd();
                    } else {
                        RewardedVideoAd.loadAd();
                        adTime = 1;
                    }
                }
            }
        }
    }

    public void bannerAds(Activity activity, ViewGroup linearLayout, final isAdLoaded isAdLoadeda) {
        if (adModel != null) {
            if (adModel.isIsad()) {
                if (adModel.isIsopenmediation()) {
                    BannerAd bannerAd = new BannerAd(adModel.getOpenmediationbannerplacementId(), new BannerAdListener() {
                        @Override
                        public void onBannerAdLoaded(String placementId, View view) {
                            // bannerAd is load success
                            if (null != view.getParent()) {
                                ((ViewGroup) view.getParent()).removeView(view);
                            }
                            linearLayout.removeAllViews();
                            linearLayout.addView(view);
                            isAdLoadeda.callback(true);
                        }

                        @Override
                        public void onBannerAdLoadFailed(String s, Error error) {
                            isAdLoadeda.callback(true);
                        }

                        @Override
                        public void onBannerAdClicked(String placementId) {
                            // bannerAd click
                        }
                    });
                    bannerAd.setAdSize(com.openmediation.sdk.banner.AdSize.BANNER);
                    bannerAd.loadAd();

                } else if (adModel.isIsqurekaads()) {
                    RelativeLayout adView = (RelativeLayout) ((Activity) activity).getLayoutInflater().inflate(R.layout.layout_qureka_bannerads, null);

                    ImageView bannerimage = adView.findViewById(R.id.bannerimage);
                    int[] bannerarray = new int[]{R.drawable.banner1, R.drawable.banner2, R.drawable.banner3, R.drawable.banner4};
                    int random = new Random().nextInt(5 - 1);

                    try {
                        bannerimage.setImageDrawable(activity.getResources().getDrawable(bannerarray[random]));
                    } catch (Resources.NotFoundException e) {
                        e.printStackTrace();
                        bannerimage.setImageDrawable(activity.getResources().getDrawable(R.drawable.banner1));
                    }

                    adView.findViewById(R.id.clickQureka).setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            openPlayGames(activity.getApplicationContext());
                        }
                    });

                    linearLayout.removeAllViews();
                    linearLayout.addView(adView);
                } else {
                    Pack5Banner.showBannerAdsMain(linearLayout, activity);

                }
            } else isAdLoadeda.callback(true);
        } else {
            isAdLoadeda.callback(true);
        }

    }


    public void nativeAds(Activity activity, final ViewGroup frameLayout, final isAdLoaded isAdLoadeda, String type) {


        if (adModel != null) {
            if (adModel.isIsad()) {
                if (adModel.isIsopenmediation()) {
                    openMediationListener(frameLayout, activity, isAdLoadeda);
                } else if (adModel.isIsqurekaads()) {
                    RelativeLayout adView = (RelativeLayout) (activity).getLayoutInflater().inflate(R.layout.layout_qureka_nativeads, null);

                    ImageView nativeimages = adView.findViewById(R.id.nativeimages);
                    int[] nativearray = new int[]{R.drawable.native_banner_1, R.drawable.native_banner_2, R.drawable.native_banner_3, R.drawable.native_banner_4};
                    int random = new Random().nextInt(5 - 1);

                    try {
                        nativeimages.setImageDrawable(activity.getResources().getDrawable(nativearray[random]));
                    } catch (Resources.NotFoundException e) {
                        e.printStackTrace();
                        nativeimages.setImageDrawable(activity.getResources().getDrawable(R.drawable.native_banner_1));
                    }

                    adView.findViewById(R.id.clickQureka).setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            openPlayGames(activity.getApplicationContext());
                        }
                    });

                    frameLayout.removeAllViews();
                    frameLayout.addView(adView);
                } else {

                    if (type.equalsIgnoreCase("0")) {
                        Pack5NativeCustom.showNativeAdsBigMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("1")) {
                        Pack5NativeNormal.showNativeAdsBigMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("2")) {
                        Pack5NativeRegular.showNativeAdsBigMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("3")) {
                        Pack5NativeSmall.showNativeAdsSmallMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("4")) {
                        Pack5NativeSmallDown_Nomedia.showNativeAdsSmallMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("5")) {
                        Pack5NativeSmallSide.showNativeAdsSmallMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("6")) {
                        Pack5NativeSmallUp.showNativeAdsSmallMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("7")) {
                        Pack5NativeBigUpMedia.showNativeAdsBigMain(frameLayout, activity);
                    } else if (type.equalsIgnoreCase("8")) {
                        Pack5NativeBigUpNoMedia.showNativeAdsBigMain(frameLayout, activity);
                    }

                }
            } else {
                isAdLoadeda.callback(true);
            }
        } else {
            isAdLoadeda.callback(true);
        }
    }

    public void CloseActivityWithAds(Activity activity, isAdLoaded isIntersttialLoded) {
        if (adModel != null) {
            if (adModel.isIsad()) {

                new ads().showints(isIntersttialLoded);
            }
        }
    }

    private com.openmediation.sdk.nativead.NativeAdView nativeAdView;

    void openMediationListener(ViewGroup adContainer, Activity activity,
                               final isAdLoaded isAdLoadeda) {
        final AdInfo[] adInfo = new AdInfo[1];
        NativeAdListener listener = new NativeAdListener() {
            /**
             * Invoked when Native Ad are available.
             * You can then show the Ad by calling nativeAd.showAd().
             */
            @Override
            public void onNativeAdLoaded(String placementId, AdInfo info) {
                //native ad load success

                adContainer.removeAllViews();
                adInfo[0] = info;
                View adView;

                if (info.isTemplateRender()) {
                    adContainer.addView(info.getView());
                } else {
                    if (adModel.isIscustomeads()) {
                        adView = LayoutInflater.from(activity).inflate(R.layout.native_ad_layout, null);
                    } else {
                        adView = LayoutInflater.from(activity).inflate(R.layout.native_ad_list_item, null);
                    }
                    TextView title = adView.findViewById(R.id.ad_title);
                    RelativeLayout relativeLayoutBackgroud = adView.findViewById(R.id.backgroud);

                    title.setText(info.getTitle());
                    AppCompatButton btn = adView.findViewById(R.id.ad_btn);
                    btn.setText(info.getCallToActionText());

                    if (adModel.isIscustomeads()) {

                        if (adModel.getCustomAdText() != null) {
                            if (!adModel.getCustomAdText().isEmpty()) {
                                btn.setText(adModel.getCustomAdText());
                            } else {
                                btn.setText(info.getCallToActionText());
                            }
                        } else {
                            btn.setText(info.getCallToActionText());
                        }

                        if (adModel.getCustomButtoncolor() == null) {
                            btn.setBackgroundResource(R.drawable.grediant_bg);
                        } else {
                            btn.setBackgroundColor(Color.parseColor(adModel.getCustomButtoncolor()));
                        }
                        if (adModel.getCustomTextcolor() != null) {
                            if (!adModel.getCustomTextcolor().isEmpty()) {
                                btn.setTextColor(Color.parseColor(adModel.getCustomTextcolor()));
                            }
                        }
                        if (adModel.getCustomTitleColor() != null) {
                            if (!adModel.getCustomTitleColor().isEmpty()) {
                                title.setTextColor(Color.parseColor(adModel.getCustomTitleColor()));
                            } else {
                                title.setTextColor(currentActivity.getResources().getColor(android.R.color.holo_blue_bright));
                            }
                        }

                        if (adModel.getCustomBackgroundColor() != null) {
                            if (!adModel.getCustomBackgroundColor().isEmpty()) {
                                relativeLayoutBackgroud.setBackgroundColor(Color.parseColor(adModel.getCustomBackgroundColor()));
                            } else {
                                relativeLayoutBackgroud.setBackgroundColor(currentActivity.getResources().getColor(android.R.color.transparent));
                            }
                        }
                    }

                    com.openmediation.sdk.nativead.MediaView mediaView = adView.findViewById(R.id.ad_media);
                    nativeAdView = new com.openmediation.sdk.nativead.NativeAdView(activity);
                    AdIconView adIconView = adView.findViewById(R.id.ad_icon_media);
                    nativeAdView.addView(adView);
                    nativeAdView.setTitleView(title);
                    nativeAdView.setAdIconView(adIconView);
                    nativeAdView.setCallToActionView(btn);

                    nativeAdView.setMediaView(mediaView);

                    com.openmediation.sdk.nativead.NativeAd.registerNativeAdView(placementId, nativeAdView, info);
                    RelativeLayout.LayoutParams layoutParams = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
                    adContainer.addView(nativeAdView, layoutParams);
                }
                isAdLoadeda.callback(true);
            }


            /**
             * Invoked when the call to load a Native Ad has failed
             * String error contains the reason for the failure.
             */
            @Override
            public void onNativeAdLoadFailed(String placementId, Error error) {
                isAdLoadeda.callback(true);
                //native ad load failed
            }

            /**
             * Invoked when an impression is recorded for NativeAd.
             */
            @Override
            public void onNativeAdImpression(String placementId, AdInfo info) {
                //native ad impression
            }

            @Override
            public void onNativeAdClicked(String s, AdInfo adInfo) {

            }

        };
        com.openmediation.sdk.nativead.NativeAd.addAdListener(adModel.getOpenmediationNativeplacementId(), listener);
        com.openmediation.sdk.nativead.NativeAd.loadAd(adModel.getOpenmediationNativeplacementId());
    }
}
