package com.demoad.plugin_codelab.adhelper.helpers;

import android.app.Activity;
import android.app.Dialog;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.WindowManager;

import com.demoad.plugin_codelab.R;

public class AdsLoadingDialog {
    public static Dialog loadAdsDialog;

    public static void showAdsLoadingDialog(Activity activity) {
        if (loadAdsDialog == null || !loadAdsDialog.isShowing() || !activity.isFinishing()) {
            loadAdsDialog = new Dialog(activity);
            loadAdsDialog.setContentView(R.layout.layout_loading);
            loadAdsDialog.setCanceledOnTouchOutside(false);
            loadAdsDialog.setCancelable(false);
            loadAdsDialog.getWindow().setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT);
            loadAdsDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
            loadAdsDialog.getWindow().getAttributes().windowAnimations = android.R.style.Animation_Dialog;
            loadAdsDialog.show();
        }
    }

    public static void dismissAdsLoadingDialog(Activity activity){
            if (loadAdsDialog != null && loadAdsDialog.isShowing() && !activity.isFinishing()) {
                loadAdsDialog.dismiss();
            }
    }

}
